For many embedded devices, the FreeRTOS+TCP porting is already or partially implemented. For example for LPC1768 platform the porting was already available, but it needed some adjustments, because the LPC1768 is quite old and it's currently not widely used, while FreeRTOS+TCP library is relatively new and daily updated.

In this chapter there is showed the modification that you need to do if you want to make a new platform porting and the adjustment introduced in the platform porting already implemented.  

%========================================================
\section{New platform porting}

To perform a correct porting of your platform you have to follow the following steps:

\begin{enumerate}
	\item \textbf{Compiler packed structure definition}: check in the \textit{FreeRTOS-Plus/FreeRTOS-Plus-TCP/portable/Compiler} folder for the compiler that your platform needs to be cross-compiled. In the compiler folder that you chose you should find two files: \textit{pack\_struct\_start.h} and \textit{pack\_str\-uct\_start.h}, that you need to import in your project. Normally, C compilers lay out the memory used to hold a C structure in a optimised way, this means empty padding bytes are placed between C structure members to achieve a byte alignment. Since FreeRTOS+TCP uses data structure to map protocol headers in Ethernet frames, we don't have padding spaces inside the structure, there we have to use a packed structure that can be defined in these two files.
	\item \textbf{Choose the buffer allocator}: choose the buffer allocator source implementation from the \textit{FreeRTOS-Plus/FreeRTOS\_Plus\_TCP/portable\-/BufferManagement} directory. \textit{BufferAllocation\_1.c} is for static allocation, in the other hand \textit{BufferAllocation\_2.c} is for dynamic allocation. For \textit{BufferAllocation\_2.c} is recommended that \textit{heap\_4.c} or \textit{heap\_5.c }is used
	\item \textbf{Protocol MAC layer}: to implement the lower protocol layer you should import in your project the Ethernet MAC driver, specific of your platform. For high throughput the MAC driver must make efficient use of the DMA and avoid copying data where possible. If your platform has an Ethernet chip with the related port, the device producer has to provide an associated driver. 
	\item \textbf{FreeRTOS+TCP layer implementation}: after importing and configuring the Ethernet MAC driver, you can implement the real FreeRTOS+TCP porting. This passage can be performed by implementing the following functions: 
	\begin{itemize}
		\item \verb|xNetworkInterfaceInitialise|: invoke the Ethernet MAC peripheral drivers to send and receive data.
		\item \verb|xNetworkInterfaceOutput|: return whenever a network buffer is ready to be transmitted.
		\item \verb|vNetworkInterfaceAllocateRAMToBuffers|: only used when \textit{BufferAllocation\_1.c} is linked in the project, because data can be only allocated statically, therefore we need a function called during device boot, that allocates statically a declared buffer to each descriptor.
	\end{itemize}
\end{enumerate}
In\textit{FreeRTOS-Plus-TCP/portable/NetworkInterface} you can see some porting implementation already done for some platform. 

%========================================================
\section{LPC1768 porting}
You can find the LPC1768 device porting in \textit{FreeRTOS-Plus-TCP/portable/N\-etworkInterface/LPC17xx} directory, but it needs some modifications explained in this section.

The \textit{NetworkInterface.c} source porting file needs two additional includes at the top: 
\begin{lstlisting}
#include "FreeRTOS_IP.h"
#include "FreeRTOS_IP_Private.h"
\end{lstlisting}[language=C]
In addition the \verb|xNetworkInterfaceOutput| function signature is wrong, because in FreeRTOS+TCP library LPC1768 is declared without a parameter: 
\begin{lstlisting}[language=C]
BaseType_t xNetworkInterfaceOutput(
	NetworkBufferDescriptor_t *const pxNetworkBuffer)
\end{lstlisting}
However the current \verb|xNetworkInterfaceOutput| function signature has the \verb|xReleaseAfterSend| parameter in addition, that has been introduced in the last FreeRTOS+TCP releases, but the LPC1768 porting has not been updated because it is a device nowadays not much used and a bit old: 
\begin{lstlisting}[language=C]
BaseType_t xNetworkInterfaceOutput(
	NetworkBufferDescriptor_t *const pxNetworkBuffer,
	BaseType_t xReleaseAfterSend)
\end{lstlisting}
Finally, the field of the \verb|NetworkBufferDescriptor_t| data structure used in \verb|EMAC\_SetNextPacketToSend| and \verb|EMAC_NextPacketToRead| functions, named \verb|pucBuffer| has to be renamed in \verb|pucEthernetBuffer|, because for the same reason before, the \verb|NetworkBufferDescriptor_t| data structure has been updated but not the LPC1768 code after the library release. 

In our LPC1768 EMAC device driver, we don't have the \texttt{EMAC\_SetNextP\-acketToSend} implementation function, that is called in \texttt{xNetworkInterface\-Output} of the \textit{NetworkInterface.c} source porting file. There we had to find an equivalent substitution that is the following: 
\begin{lstlisting}[language=C]
EMAC_SetNextPacketToSend(
	pxNetworkBuffer->pucEthernetBuffer);
EMAC_PACKETBUF_Type TXBuffer;
TXBuffer.ulDataLen = pxNetworkBuffer->xDataLength;
TXBuffer.pbDataBuf = 
	(uint32_t *)pxNetworkBuffer->pucEthernetBuffer;
EMAC_WritePacketBuffer(&TXBuffer);
EMAC_UpdateTxProduceIndex();
\end{lstlisting}